# MogHA

本项目为MogDB/openGuass数据库的高可用组件，用于管理数据库的高可用切换等处理。

注：前置警告，不建议使用gs_om管理数据库的主备实例启停，建议使用gs_ctl 命令启停数据库服务，已知gs_om存在部分操作无法跟随更新的问题

```bash
gs_ctl start -M primary # 启动为主库
gs_ctl start -M standby # 启动为备库
gs_ctl build -b full # 如果备库出现错误, 需要重置时候 (需要删除当前备库所有数据,操作前做好备份)
```

## 安装

安装包下载地址: http://wiki.enmotech.com:8090/pages/viewpage.action?pageId=24808918

下载后得到一个类似 `mogha-x.x.x.tar.gz` 的压缩包（`x` 代表版本号）

###  前期准备

#### python3.6+

由于HA的运行依赖 python3.6+ 的环境，所以请在安装前确认当前服务器能够正常执行 python3 指令，同时检查 python3 的版本。

确认方式：

```bash
command -v python3
# 输出 /usr/bin/python3 路径不一定一样，确保存在即可
python3 -V
# 输出的版本在 Python 3.6 以上就满足安装条件
```

#### gsql, gs_ctl 免密执行

请确保在数据库数据目录中的 `pg_hba.conf` 中， `host all	all	127.0.0.1/32	trust ` 这一行存在，且处于考前的位置（不一定非要第一行，但需确保在本机IP所有在行之前，因为pg 校验的时候是从上到下执行规则的）

测试方式，执行下面的命令不需要输入密码即可查询到集群状态：

```
gs_ctl -D [PGDATA] query 
```

#### 数据库安装用户的sudo权限

假设安装数据库的用户为 `omm`， 则需要服务 omm 用户 ifconfig 和 systemctl 的执行权限

配置方式参考：

```bash
配置用户的sudo权限
chmod +w /etc/sudoers

which systemctl
# /usr/bin/systemctl
which ifconfig
# /usr/sbin/ifconfig

vi /etc/sudoers
# 追加下列 2 行到文件末尾
omm     ALL=(ALL)       NOPASSWD: /usr/sbin/ifconfig
omm     ALL=(ALL)       NOPASSWD: /usr/sbin/systemctl
# 保存退出
chmod -w /etc/sudoers
```



## 安装步骤

> 安装的过程请全程使用 `root` 用户进行操作，涉及到给数据库安装用户sudo权限以及注册系统服务

将压缩包拷贝到要部署HA的服务器上，存放目录建议选择`数据库安装用户`的家目录，以 `omm` 为例，则存放目录为 `/home/omm/`，**为了便于演示，后面不再声明，默认使用该目录进行演示**

### 解压缩安装包

```bash
cd /home/omm
tar -zxf mogha-2.1.1.tar.gz
```

解压后会在当前目录下得到一个 `mogha` 的文件夹

###安装HA服务

安装脚本执行方式：`./install.sh USER PGDATA`

`USER` 是指数据库安装用户，在本例中指 `omm` 用户

`PGDATA` 是指数据库数据目录，本例子假设我们的 MogDB 安装目录为 `/opt/mogdb/` 则数据目录为 `/opt/mogdb/data`

```bash
# 进入刚刚解压后的文件夹
cd /home/omm/mogha
# 执行安装脚本
./install.sh omm /opt/mogdb/data

# 安装过程，输出类似一下内容
[2021-07-01 10:43:24]: MogHA 安装目录为：/home/omm/mogha
[2021-07-01 10:43:24]: 数据库安装用户为：omm, 所在用户组为：dbgrp
[2021-07-01 10:43:24]: 数据库数据目录为：/opt/mogdb/data
[2021-07-01 10:43:24]: LD_LIBRARY_PATH=/opt/mogdb/app/lib:/opt/mogdb/tool/lib:
[2021-07-01 10:43:24]: GAUSSHOME=/opt/mogdb/app
[2021-07-01 10:43:24]: 当前系统架构为：aarch64
[2021-07-01 10:43:24]: 修改安装目录及其子目录或文件的用户和用户组...
[2021-07-01 10:43:24]: 链接系统的 python3 解释器到虚拟环境...
[2021-07-01 10:43:24]: 当前系统中 Python3 的路径为：/usr/bin/python3
[2021-07-01 10:43:24]: Python3 的版本为：3.7
[2021-07-01 10:43:24]: 虚拟环境中 python 解释器链接成功
[2021-07-01 10:43:24]: 生成 mogha.service 文件...
[2021-07-01 10:43:24]: 复制 mogha.service 文件到 /usr/lib/systemd/system/
[2021-07-01 10:43:24]: 重载配置文件
[2021-07-01 10:43:24]: mogha 服务注册成功
[2021-07-01 10:43:24]: 用户 omm 已经存在于 /etc/sudoers 文件中，请自行确认权限!
[2021-07-01 10:43:24]: 生成 supervisord.conf 配置文件...
[2021-07-01 10:43:24]: supervisord.conf 生成成功
[2021-07-01 10:43:24]: 发现 node.conf 已经存在，不再自动生成
[2021-07-01 10:43:24]: MogHA 安装成功!

请修改 /home/omm/mogha/node.conf 配置文件后再启动服务 !!!

启动 MogHA 的命令:
    systemctl start mogha
```

从安装脚本执行的输出结果可以大概看出安装的流程，安装成功的标志是看到输出的最后打印出了 `all done` 语句。其他情况，需根据实际情况，检查安装步骤哪里出错。

**需要注意的是**：

执行完安装脚本后，不要立即启动服务，HA的运行强烈依赖安装目录中 `node.conf` 的配置，我们需要先正确的配置了这个文件再启动服务。当第一次安装的时候，`node.conf` 一般是没有的，脚本会根据 `node.conf.tmpl` 模板文件自动生成一份 `node.conf`， 所以可以看到执行的输出最后重点强调了: `请根据您的集群信息修改 node.conf 中的配置后再启动服务`，后面将阐述，我们应该如何来进行配置 `node.conf` 。

### node.conf 的配置

#### 必须用户确认配置的字段

- 数据库连接端口

```bash
# 数据库端口，用于连接数据库
db_port=0
```

- HA通信端口

```bash
# ha节点之间通讯用的端口，如果有防火墙，需要打开这个端口的访问
agent_port=8081
```

- host 主机列表（仅选取 host1 做演示，其他相同）

  主机列表需要用户将自己的数据库集群中的所有主备实例所在的服务器的业务IP填写到 `ip` 字段。

  如果没有心跳IP的话，可以不填写置空，如果有则填写，如果有多个心跳IP，则以英文半角逗号分隔填写

```bash
# 这部分从host1-8，每个代表一个机器
[host1]
# 业务网络ip
ip=192.168.1.111
# 心跳网络ip，允许配置多个心跳网络，以逗号隔开
heartbeat_ips=192.168.1.112,192.168.1.113

```

- zone 机房列表（仅选取 zone1 做演示，其他相同）

  zone 在这里代表的是机房的概念

  `vip`：不同的机房拥有各自的虚拟IP（VIP）,虚拟IP用于业务访问，解耦服务器的私有IP，便于主备切换

  `arping`： 可以留空，系统会采用广播地址

  `ping_list`：用于检查网络的中间节点IP，一般可以选择网关地址

  `hosts`：本机房中的主机列表，特别强调，这里**不是**填写主机名或主机IP，这里是用于**归类**上一步中填写的 host 列表，所以这个字段应该填写的是本配置文件中定义的 `host1`，`host2` ... 等等这种 section 名，举例：假如 `host1`, `host2` 这两个机器同属于 `zone1` 这个机房，那么这里的 `hosts` 应该填写为： `hosts=host1,host2` （以英文半角逗号分隔）

  `cascade`： 本机房中的级联备列表，配置方式同 `hosts`

```bash
# 这部分主要用于区分机房，不同机房会有自己的VIP，
[zone1]
# 本机房的VIP
vip=
# 本机房的arping地址，如果不知道，可以留空，会采用arp广播模式
arping=
# 检查网络的中间节点，一般是可以ping通的网关地址
ping_list=
# 本机房的机器列表，例如 host1,host2,host3
hosts=
# 本机房的级联备库列表
cascade=
```

#### 其他可选项配置

```bash
[config]
# 心跳间隔时间，也是主流程检查的间隔时间，一般设置为3-5s
heartbeat_interval=3

# 主库丢失的探测时间，当主库宕机无法ping到，认为持续到这个时长之后，备库可以切换为主库
primary_lost_timeout=10

# 主库的孤单时间，当主库无法连接到其他机器，ping不到其他任何机器，认为主库网络出现问题
# 当持续超过这个时长，认为主库实例需要关闭(mogdb中会设置为readonly)
primary_lonely_timeout=10

# 当双主状态持续指定时长之后，认为需要做双主判断，
# 因为在维护性操作中，会有可能存在极短时间的双主状态（此时事实上数据库不允许写入）
double_primary_timeout=10

# 数据库的操作系统用户，通常为omm或者postgres
db_user=__USER__

# 数据库的数据目录，用于信号发送等本地通讯行为
db_datadir=__PGDATA__

# 本地元数据文件类型:
#   - "json" : json 格式
#   - "bin" : 二进制格式 (如果该参数没有配置，默认使用 bin)
meta_file_type=json

# 本地元数据存储位置，自动维护无需人工干预，当元数据库不可用时候，用这个数据作为主库判断
primary_info=__INSTALLDIR__/primary_info

# 本地元数据存储位置，自动维护无需人工干预，当主库丢失，备库依赖这个去判断自身同步状态
standby_info=__INSTALLDIR__/standby_info

# 是否为数据库实例设置cpu限制，True的话，会保留至少一个cpu出来不分配给数据库用
taskset=True

# 是否使用 lite 模式，可选值：True / False
# lite 模式下，即便是一主多备，也只需在主和同步备启动服务。
# 该值为 False 的话，即为 full 模式，需要在所有节点启动高可用服务。
# 二者的区别：lite 模式，HA服务不会修改数据库的主备相关配置，而 full 模式下会自动修改
lite_mode=False

# 是否使用元数据库。
# 如果值为 True，需在下面的 [meta] 部分，配置元数据库连接参数，
# 如果值为 False，[meta] 部分可以置空
use_meta=False

# 设置输出的日志格式
logger_format=%(asctime)s - %(name)s - %(levelname)s [%(filename)s:%(lineno)d]: %(message)s

# 设置除了主备相关的机器，允许可以访问到web接口的IP列表, 多个IP时英文半角逗号分隔
allow_ips=

# [v2.1新增] 主库实例进程未启动时，如何处理
# 支持两种处理方式：
#   restart: 尝试重启，尝试次数在 restart_instance_limit 参数中设定
#   failover: 备库升为主，主库尝试重建数据库后启动为备
primary_down_handle_method=failover

# [v2.1新增] 重启实例最大尝试条件: times/minutes
# 例如： 10/3 最多尝试10次或者3分钟，任何一个条件先满足就不再尝试。
restart_strategy=10/3

# 这部分都是元数据库的连接参数（opengauss数据库），
# 不强依赖，配置错误会在日志中提示，但不影响 HA 调度
[meta]
ha_name=    # ha主备的名称，全局必须唯一，禁止两套主备共用一个名字
host=       # 数据库机器
port=       # 数据库端口
db=         # 数据库的database
user=       # 用户名
password=   # 密码
schema=     # 使用的schema
```

### SUDO权限

由于HA 或涉及到自动挂 VIP 的操作，内部会通过 `ifconfig` 指令来进行操作网卡，但HA在运行期间是通过数据库安装用户进行运行的，要想执行网卡操作就需要 sudo 权限，在安装期间 `install.sh` 脚本中会尝试自动的将 `omm` 用户添加到 `/etc/sudoers` 中，并赋予 `ifconfig` 和 `systemctl` 的权限，但不能完全确保操作成功。所以建议在启动HA服务之前，先检查一下 `/etc/sudoers` 中是否成功写入 omm 用户的 sudo 权限。

### 启动服务

确认配置完成 `node.conf` 以后，就可以启动 HA 服务了，启动方式为：

```bash
sudo systemctl start mogha
```

启动后检查 mogha 的运行状态:

```bash
sudo systemctl status mogha
● mogha.service - MogDB/openGuass HA manager service
   Loaded: loaded (/usr/lib/systemd/system/mogha.service; disabled; vendor preset: disabled)
   Active: active (running) since Tue 2021-06-22 10:17:19 CST; 2s ago
 Main PID: 832531 (supervisord)
    Tasks: 16
   Memory: 144.1M
   CGroup: /system.slice/mogha.service
           ├─832531 /home/omm/mogha/prod_venv/bin/python /home/omm/mogha/prod_venv/bin/supervisord -c /home/omm/mogha/supervisord.conf
           ├─832548 /home/omm/mogha/mogha_2_1_aarch64 --config /home/omm/mogha/node.conf --heartbeat
           ├─832549 /home/omm/mogha/mogha_2_1_aarch64 --config /home/omm/mogha/node.conf --web
           ├─832550 /home/omm/mogha/mogha_2_1_aarch64 --config /home/omm/mogha/node.conf --heartbeat
           └─832551 /home/omm/mogha/mogha_2_1_aarch64 --config /home/omm/mogha/node.conf --web

Jun 22 10:17:19 mogdb-manager-0004 systemd[1]: mogha.service: Succeeded.
Jun 22 10:17:19 mogdb-manager-0004 systemd[1]: Stopped MogDB/openGuass HA manager service.
Jun 22 10:17:19 mogdb-manager-0004 systemd[1]: Started MogDB/openGuass HA manager service.
Jun 22 10:17:19 mogdb-manager-0004 supervisord[832531]: 2021-06-22 10:17:19,967 INFO supervisord started with pid 832531
Jun 22 10:17:20 mogdb-manager-0004 supervisord[832531]: 2021-06-22 10:17:20,969 INFO spawned: 'heartbeat' with pid 832548
Jun 22 10:17:20 mogdb-manager-0004 supervisord[832531]: 2021-06-22 10:17:20,971 INFO spawned: 'web' with pid 832549
```

重启HA:

```bash
sudo systemctl restart mogha
```

停止HA：

```bash
sudo systemctl stop mogha
```

### 日志文件

HA内部会生成两个日志文件：

- mogha_heartbeat.log

  这个日志文件会存放在安装目录中，在本示例中为 `/home/omm/mogha`，这个日志主要记录HA的心跳日志，也是排查问题主要的优先检查的日志文件。

- mogha_web.log

  这个日志文件存放目录和心跳日志相同。这个日志主要记录 web api 接口的请求日志。

supervisord 做为管理HA的进程管理工具也会产生一个日志文件，存放于 `/tmp/mogha_supervisord.log`

## 卸载软件

进入安装目录，执行卸载脚本即可：

```bash
cd /home/omm/mogha
./uninstall.sh

# 过程输出如下
[2021-07-01 11:09:07]: 尝试停止 mogha (systemctl stop mogha)
[2021-07-01 11:09:08]: 删除注册文件
[2021-07-01 11:09:08]: 卸载成功
```

## 常见问题

- 为什么启动MogHA以后，通过 `ps -ef|grep mogha` 会看到四个进程（两个web，两个heartbeat）?

  MogHA是使用 Python 语言进行开发的，由于Python的代码运行依赖于Python解释器和三方依赖包，为了减少部署时对于系统的过多要求，或者避免对于网络的依赖，MogHA 在发包的时候，采用了 Pyinstaller 这个工具来进行打包。由于 Pyinstaller 这个工具的设计，打包后的执行文件在执行时，程序会被解压到一个临时目录中去运行。运行启动时，工具会启动两个进程，一个是实际的**工作进程**，一个用于在工作进程崩溃时进行清理临时目录的**清理进程**，但从 `ps` 查看的话，变现就是两个启动指令相同的进程。

  因为我们的MogHA会运行两次执行文件来启动 web 进程和 heartbeat 进程，所以相应的就会出现四个进程。


## lite模式和 full 模式

lite模式下，有额外的手工操作，根据不同的部署和预设形态，手工操作命令有小差别。

与full模式比较，核心区别在ha启动的范围，full模式要求所有数据库机器都启动mogha服务lite只需要人工指定的主和备启动服务（可以视为一主一备情况的部署使用）

完成一次切换后，需要如下操作：

1. 设置新的同步备库 设置新主库的synchronous_standby_names 格式为 2 (同步备1,同步备2)
2. 启动新的同步备库的mogha服务