#!/bin/bash

set -e

function log() {
  message="[$(date +%Y-%m-%d\ %H:%M:%S)]: $1"
  echo $message
  if [ $# -eq 2 ];then
   echo $message >> $2
  fi
}

SVC_FILE="/usr/lib/systemd/system/mogha.service"
if [ ! -f ${SVC_FILE} ]
then
  log "未发现 mogha 服务文件，无需卸载"
else
  log "尝试停止 mogha (systemctl stop mogha)"
  systemctl stop mogha
  log "删除注册文件"
  rm -f ${SVC_FILE}
  systemctl daemon-reload
  log "卸载成功"
fi